from haystack import indexes
from .forms import ArtefactForm
from .models import Artefact
from .views import get_section_groups

import bs4


class ArtefactIndex(indexes.SearchIndex, indexes.Indexable):
    # main document field holding full text related to the artefact
    text = indexes.CharField(document=True, use_template=True)

    # facet fields
    country = indexes.CharField(model_attr='origin__city__country__name',  default='Unspecified',  faceted=True)
    metal_e_1 = indexes.CharField(model_attr='metal_e_1',  default='Unspecified', faceted=True)
    corrosion_form = indexes.CharField(model_attr='corrosion_form__form',  default='Unspecified', faceted=True)
    environment = indexes.CharField(model_attr='environment',  default='Unspecified', faceted=True)


    def get_model(self):
        return Artefact

    def index_queryset(self, using=None):
        """
        Used when the entire index for model is updated.
        """
        return self.get_model().objects.filter(published=True)

    def prepare(self, obj):
        """
        Override this method to provide any custom preparation logic.
        """
        # retrieve the default content generated by the artefact_text.txt template
        prepared_data = super(ArtefactIndex, self).prepare(obj)

        # create a full text "view" (artefact_update_page like) of the artefact object
        # including full sections content
        artefact_form = ArtefactForm(instance=obj, label_suffix='')
        full_initial = {'name':obj.object.name}
        full_initial.update(artefact_form.initial)
        bound_form = ArtefactForm(full_initial,instance=obj)
        bound_form.is_valid()

        # content = '<BR>'.join(section.content + section.complementary_information for section in obj.section_set.exclude(content=None))
        section_groups = get_section_groups(obj, artefact_form,None)
        # some of the artefact's data are stored as html (e.g. content / complementary information)
        html_content = ''
        for sections in section_groups:
            for s in sections:
                section = s['section']
                fieldset = s['fieldset']
                # fields_content for the current section
                fields_content = '\n'.join(
                    f"{fieldset.fields[field_name].label}: {bound_form.cleaned_data[field_name]}" for field_name in
                    fieldset.fields)
                # when section.template.has_images add legend and credit
                images_content = '\n'.join(
                    f"{image.legend}\nCredit: {image.credit}" for image in section.image_set.all()
                )
                # when section.template.has_stratigraphies add legend
                statigraphies_content = '\n'.join(
                    f"{stratigraphy.legend}" for stratigraphy in section.stratigraphy_set.all()
                )

                html_content += f'\n{section.template.title}:\n'
                html_content += '\n'.join((section.content, fields_content, images_content, statigraphies_content, section.complementary_information))

        # get text only content from html_content
        soup = bs4.BeautifulSoup(html_content, 'html.parser')
        # add it to the initial template based content
        prepared_data['text'] += soup.get_text()

        return prepared_data
